package ejb30.persistence.datatypes.client;

import ejb30.persistence.datatypes.ejb.DataTypes;
import ejb30.persistence.datatypes.ejb.DataTypesSession;
import ejb30.persistence.datatypes.util.*;
import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;

import javax.naming.InitialContext;
import javax.ejb.*;
import javax.annotation.*;
import java.util.*;
import java.text.*;
import java.sql.*;
import java.io.*;

public class Client
{
   static Connection cn = null;
   private static @EJB DataTypesSession dao;
   private static SimpleReporterAdapter status =
        new SimpleReporterAdapter("appserver-sqe");

   public static void main(String[] args) throws Exception
   {
      String imagefile=args[0];
      String xmlfile=args[1];
      String testSuiteID=args[2];
      String tableName="datatypes";

      int firstrowID = 1; 	
      int secondrowID = 3; 	
      DataTypes firstrow = new DataTypes();
      DataTypes secondrow = new DataTypes();
      DataComparatorUtil testUtil=new DataComparatorUtil();
      byte[] blobdata = null;
      File file1 = new File(imagefile);
      blobdata = testUtil.getBytesFromFile(file1);
      //blobdata = testUtil.readBLOBData(imagefile);
      String clobdata=testUtil.readCLOBData(xmlfile);

      status.addDescription(" Testing EJB 3.0 DataTypes ");

// get test for imported CLOB 
/*
      try {
     	secondrow = dao.find(secondrowID);
        //System.out.println("secondrow ="+secondrow +"\n secondrowID ="+secondrowID);
        String retrievedData=secondrow.getClobData();
	if(retrievedData==null) {
                System.out.println(testSuiteID+ "set-ImportedCLOB-data: FAIL");
                status.addStatus(testSuiteID+" "+"set-ImportedCLOB-data",status.FAIL);
	} else {
                System.out.println(testSuiteID+ "set-ImportedCLOB-data: PASS");
                status.addStatus(testSuiteID+" "+"set-ImportedCLOB-data",status.PASS);
	}

        //System.out.println("xml file retrieved from CMP bean ="+retrievedData);
        if(retrievedData.compareTo(clobdata) == 0) {
                System.out.println(testSuiteID+ "get-ImportedCLOB-data: PASS");
                status.addStatus(testSuiteID+" "+"get-ImportedCLOB-data",status.PASS);
        } else {
                System.out.println(testSuiteID+ "get-ImportedCLOB-data: FAIL");
                status.addStatus(testSuiteID+" "+"get-ImportedCLOB-data",status.FAIL);
        }
      } catch (Exception e) {
        	System.out.println(testSuiteID+ "get-ImportedCLOB-data: FAIL");
        	System.out.println("Exception Caught: " + e );
                status.addStatus(testSuiteID+" "+"set-ImportedCLOB-data",status.FAIL);
        	status.addStatus(testSuiteID+ " get-ImportedCLOB-data", status.FAIL);
      }

// get test for imported BLOB 
     try {
        byte[] blobDatarecv=new byte[blobdata.length];
        blobDatarecv=secondrow.getBlobData();
	if(blobDatarecv==null) {
                System.out.println(testSuiteID+ "set-ImportedBLOB-data: FAIL");
                status.addStatus(testSuiteID+" "+"set-ImportedBLOB-data",status.FAIL);
	} else {
                System.out.println(testSuiteID+ "set-ImportedBLOB-data: PASS");
                status.addStatus(testSuiteID+" "+"set-ImportedBLOB-data",status.PASS);
	}

        //System.out.println("Original BLOB file:\n");
        //System.out.println("Imported/retrieved BLOB file from CMP bean:\n");
        boolean compareResult=testUtil.compareBLOBData(blobDatarecv,blobdata);
        if(compareResult==true){
          	System.out.println(testSuiteID+" get-ImportedBLOB-data: PASS");
          	status.addStatus(testSuiteID+" "+"get-ImportedBLOB-data",status.PASS);
        } else {
          	System.out.println(testSuiteID+" get-ImportedBLOB-data: FAIL");
          	status.addStatus(testSuiteID+" "+"get-ImportedBLOB-data",status.FAIL);
		}
        } catch (Exception e) {
        	System.out.println(testSuiteID+ "get-ImportedBLOB-data: FAIL");
        	System.out.println("Exception Caught: " + e );
                status.addStatus(testSuiteID+" "+"set-ImportedBLOB-data",status.FAIL);
        	status.addStatus(testSuiteID+ " get-ImportedBLOB-data", status.FAIL);
        }

*/
     try {
//BLOB CLOB write test
        //System.out.println("Original CLOB file ............... ="+clobdata);
      	firstrowID = dao.create(1, new Integer(Integer.MAX_VALUE), clobdata, blobdata);
        status.addStatus(testSuiteID+" set-BLOB-data-EM ",status.PASS);
        status.addStatus(testSuiteID+" set-CLOB-data-EM ",status.PASS);

     	firstrow = dao.find(firstrowID);
     	if(firstrow.getIntegerData().equals(new Integer(Integer.MAX_VALUE))){
       	status.addStatus(testSuiteID+" Populate_Integer_MAXVAL", status.PASS);
     	} else
    	   status.addStatus(testSuiteID+" Populate_Integer_MAXVAL", status.FAIL);

// BLOB get test
        byte[] blobDatarecv1=new byte[blobdata.length];
        blobDatarecv1=firstrow.getBlobData();
        //System.out.println("Imported/retrieved BLOB file from CMP bean:\n");
        boolean compareResult=testUtil.compareBLOBData(blobDatarecv1,blobdata);
        if(compareResult==true){
          System.out.println(testSuiteID+" get-BLOB-data-EM: PASS");
          status.addStatus(testSuiteID+" "+"get-BLOB-data-EM",status.PASS);
        } else {
          System.out.println(testSuiteID+" get-BLOB-data-EM: FAIL");
          status.addStatus(testSuiteID+" "+"get-BLOB-data-EM",status.FAIL);
        }

//CLOB get test
        String retrievedData=firstrow.getClobData();
        System.out.println("xml file retrieved from CMP bean\n"+retrievedData);
        //System.out.println("compareTo results: \n"+retrievedData.compareTo(clobdata));
        if(retrievedData.compareTo(clobdata) == 0) {
          	System.out.println(testSuiteID+ "get-CLOB-data-EM: PASS");
                status.addStatus(testSuiteID+" "+"get-CLOB-data-EM",status.PASS);
        } else {
          	System.out.println(testSuiteID+ "get-CLOB-data-EM: FAIL");
                status.addStatus(testSuiteID+" "+"get-CLOB-data-EM",status.FAIL);
	}
     } catch (Exception e) {
        System.out.println(testSuiteID+ "EM-BLOB-CLOB-Test: FAIL");
        System.out.println("Exception Caught: " + e );
        status.addStatus(testSuiteID+ " EM-BLOB-CLOB-Test", status.FAIL);
     }

     status.printSummary(" EJB 3.0 DataTypes Tests: ");
   }

}
