package ejb30.persistence.datatypes.client;

import javax.persistence.*;
import javax.ejb.*;
import javax.annotation.*;
import java.util.*;
import java.text.*;
import java.io.*;

import ejb30.persistence.datatypes.ejb.*;
import ejb30.persistence.datatypes.util.*;
import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;

public class TestOutsideContainer {

    public static String imagefile = "";
    public static String xmlfile = "";
    public static byte[] blobdata = null;
    public static String clobdata = "";
    public static DataComparatorUtil testUtil=new DataComparatorUtil();
    public static DataTypes firstRow = new DataTypes();
    public static DataTypes secondRow = new DataTypes();

    public static DataTypes dataRow = new DataTypes();
    public static String testSuiteID = "";
    public static String runMode = "";
    public static String regMode = "regular";
    private static SimpleReporterAdapter status = new SimpleReporterAdapter("appserver-sqe");

    public static void main(String[] args) {
        imagefile = args[0];
        xmlfile = args[1];
        testSuiteID = args[2];
        runMode = args[3];

    	File file1 = new File(imagefile);
	try {
    	  blobdata = testUtil.getBytesFromFile(file1);
                System.out.println(testSuiteID+ "get-ImportedBLOB-data: PASS");
	} catch (Exception e) {
                System.out.println(testSuiteID+ "get-ImportedBLOB-data: FAIL");
                System.out.println("Exception Caught: " + e );
      	}

    	clobdata=testUtil.readCLOBData(xmlfile);

	status.addDescription(" Testing EJB 3.0 blobclob ");
        TestOutsideContainer client = new TestOutsideContainer();

        client.run();
     	status.printSummary(" EJB 3.0 " + testSuiteID +" Tests: ");
	System.out.println(" EJB 3.0 " + testSuiteID +" Tests: ");
    }

    public void run() {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("manager", new HashMap());
        EntityManager manager = emf.createEntityManager();
        EntityTransaction tx = manager.getTransaction();
	secondRow = manager.find(DataTypes.class, 3);

        System.out.println("BLOB test running mode ======================================:" + runMode);
        tx.begin();
	  if (runMode.compareTo(regMode) == 0) {
	    getImportedCLOB(manager);
	    getImportedBLOB(manager); }
	  createDataTypes(manager);
	  readData(manager);
	  blobGet(manager);
	  clobGet(manager);
        tx.commit();
        manager.close();
	emf.close();
    }

    public void createDataTypes(EntityManager manager)
    {
        SimpleDateFormat sdf = new SimpleDateFormat ("dd-MM-yyyy HH:mm");
	try {
		dataRow = new DataTypes(1, new Integer(Integer.MAX_VALUE), clobdata, blobdata);
		manager.persist(dataRow);
        	status.addStatus(testSuiteID+" set-BLOB-data-EM ",status.PASS);
        	status.addStatus(testSuiteID+" set-CLOB-data-EM ",status.PASS);
	} catch (Exception e) {
        	System.out.println("Exception Caught: " + e );
        	status.addStatus(testSuiteID+" set-BLOB-data-EM ",status.FAIL);
        }
     }

     public void readData(EntityManager manager)
     {
	firstRow = manager.find(DataTypes.class, dataRow.getId());
        if(firstRow.getIntegerData().equals(new Integer(Integer.MAX_VALUE))){
        status.addStatus(testSuiteID+" Read_BLOBCLOB_Row", status.PASS);
        } else
           status.addStatus(testSuiteID+" Read_BLOBCLOB_Row", status.FAIL);
     }

     public void blobGet(EntityManager manager)
     {
        byte[] blobDatarecv1=new byte[blobdata.length];
        blobDatarecv1 = firstRow.getBlobData();
        //System.out.println("Imported/retrieved BLOB file from CMP bean:\n");
        boolean compareResult=testUtil.compareBLOBData(blobDatarecv1,blobdata);
        if(compareResult==true){
          System.out.println(testSuiteID+" get-BLOB-data-EM: PASS");
          status.addStatus(testSuiteID+" "+"get-BLOB-data-EM",status.PASS);
        } else {
          System.out.println(testSuiteID+" get-BLOB-data-EM: FAIL");
          status.addStatus(testSuiteID+" "+"get-BLOB-data-EM",status.FAIL);
        }
     }

     public void clobGet(EntityManager manager)
     {
        String retrievedData = firstRow.getClobData();
        System.out.println("xml file retrieved from DB\n" + retrievedData);
        //System.out.println("compareTo results: \n"+retrievedData.compareTo(clobdata));
        if(retrievedData.compareTo(clobdata) == 0) {
                System.out.println(testSuiteID+ "get-CLOB-data-EM: PASS");
                status.addStatus(testSuiteID+" "+"get-CLOB-data-EM",status.PASS);
        } else {
                System.out.println(testSuiteID+ "get-CLOB-data-EM: FAIL");
                status.addStatus(testSuiteID+" "+"get-CLOB-data-EM",status.FAIL);
        }
     }

     public void getImportedCLOB(EntityManager manager)
     {
      try {
        String retrievedData=secondRow.getClobData();
        if(retrievedData==null) {
                System.out.println(testSuiteID+ "set-ImportedCLOB-data: FAIL");
                status.addStatus(testSuiteID+" "+"set-ImportedCLOB-data",status.FAIL);
        } else {
                System.out.println(testSuiteID+ "set-ImportedCLOB-data: PASS");
                status.addStatus(testSuiteID+" "+"set-ImportedCLOB-data",status.PASS);
        }

        //System.out.println("xml file retrieved from CMP bean ="+retrievedData);
        if(retrievedData.compareTo(clobdata) == 0) {
                System.out.println(testSuiteID+ "get-ImportedCLOB-data: PASS");
                status.addStatus(testSuiteID+" "+"get-ImportedCLOB-data",status.PASS);
        } else {
                System.out.println(testSuiteID+ "get-ImportedCLOB-data: FAIL");
                status.addStatus(testSuiteID+" "+"get-ImportedCLOB-data",status.FAIL);
        }
      } catch (Exception e) {
                System.out.println(testSuiteID+ "get-ImportedCLOB-data: FAIL");
                System.out.println("Exception Caught: " + e );
                status.addStatus(testSuiteID+" "+"set-ImportedCLOB-data",status.FAIL);
                status.addStatus(testSuiteID+ " get-ImportedCLOB-data", status.FAIL);
      }
     }

     public void getImportedBLOB(EntityManager manager)
     {
     try {
        byte[] blobDatarecv=new byte[blobdata.length];
        blobDatarecv=secondRow.getBlobData();
        if(blobDatarecv==null) {
                System.out.println(testSuiteID+ "set-ImportedBLOB-data: FAIL");
                status.addStatus(testSuiteID+" "+"set-ImportedBLOB-data",status.FAIL);
        } else {
                System.out.println(testSuiteID+ "set-ImportedBLOB-data: PASS");
                status.addStatus(testSuiteID+" "+"set-ImportedBLOB-data",status.PASS);
        }

        //System.out.println("Original BLOB file:\n");
        //System.out.println("Imported/retrieved BLOB file from CMP bean:\n");
        boolean compareResult=testUtil.compareBLOBData(blobDatarecv,blobdata);
        if(compareResult==true){
                System.out.println(testSuiteID+" get-ImportedBLOB-data: PASS");
                status.addStatus(testSuiteID+" "+"get-ImportedBLOB-data",status.PASS);
        } else {
                System.out.println(testSuiteID+" get-ImportedBLOB-data: FAIL");
                status.addStatus(testSuiteID+" "+"get-ImportedBLOB-data",status.FAIL);
                }
        } catch (Exception e) {
                System.out.println(testSuiteID+ "get-ImportedBLOB-data: FAIL");
                System.out.println("Exception Caught: " + e );
                status.addStatus(testSuiteID+" "+"set-ImportedBLOB-data",status.FAIL);
                status.addStatus(testSuiteID+ " get-ImportedBLOB-data", status.FAIL);
        }
     }

}
