package ejb30.persistence.datatypes.util;

import java.io.*;
import java.sql.*;

public class DataComparatorUtil {
    
    private Connection cn;
    public byte[] readBLOBData(String imagefile){
        byte[] data=null;
        byte[] tmp=new byte[1024];
        int sz,len=0;
        try{
            FileInputStream fis=new FileInputStream(imagefile);           
            while((sz=fis.read(tmp))!=-1) {
                if(data==null){
                    len=sz;
                    data=tmp;
                }
                else{
                    byte[] narr;
                    int nlen;
                    nlen=len+sz;
                    narr=new byte[nlen];
                    System.arraycopy(data,0,narr,0,len);
                    System.arraycopy(tmp,0,narr,len,sz);
                    data=narr;
                    len=nlen;
                }
            }
            if(len!=data.length){
                byte[] narr=new byte[len];
                System.arraycopy(data,0,narr,0,len);
                data=narr;
            }            
            return data;            
        }catch(Exception e){
            System.out.println("Some exception while reading file");
            e.printStackTrace();
        }
        
        return data;
    }
    
    public static byte[] getBytesFromFile(File file) throws IOException {
        InputStream is = new FileInputStream(file);
    
        long length = file.length();
    
        if (length > Integer.MAX_VALUE) {
        	System.out.println("File is too large");
        }
    
        byte[] bytes = new byte[(int)length];
    
        int offset = 0;
        int numRead = 0;
        while (offset < bytes.length
               && (numRead=is.read(bytes, offset, bytes.length-offset)) >= 0) {
            offset += numRead;
        }
    
        if (offset < bytes.length) {
            throw new IOException("Could not completely read file "+file.getName());
        }
    
        is.close();
        return bytes;
    }
    
    public String readCLOBData(String xmlfile){
        System.out.println("Parsing XML input file--->"+xmlfile);
        StringBuffer xmlbuf=new StringBuffer();        
        try{
            FileReader fr=new FileReader(xmlfile);
            BufferedReader br=new BufferedReader(fr);
            xmlbuf=new StringBuffer();
            String s;
            while((s=br.readLine())!=null) {
                xmlbuf.append(s);
                xmlbuf.append("\n");
            }                 
            fr.close();
        }catch(Throwable e){
            System.out.println("Error while reading xml file");
            e.printStackTrace();
        }
        
        return xmlbuf.toString();
 
    }

    
    public boolean compareBLOBData(byte[] fromcmp,byte[] tocmp) {
        boolean blobCompareResult=false;  
        if(fromcmp==null | tocmp==null){
            System.out.println("data being compared is null");
            return false;
        }
        if(fromcmp.length!=tocmp.length) {
            System.out.println("Size of BLOB data input to cmp and output from");
            System.out.println("..doesn't match");
            blobCompareResult=false;
            return false;
        }
        else{
           
            for(int i=0,j=0;i<tocmp.length;i++,j++){
                if(fromcmp[i]!=tocmp[j]){
                    blobCompareResult=false;
                    return false;
                    
                }
                else
                    blobCompareResult=true;
            }
        }
        return blobCompareResult;
        
    }

    public void printlnByteArray(byte[] ba) {
        if (ba != null) {
            for (int i = 0; i < ba.length; i++) {
                System.out.print((char)ba[i]);
            }
        }
        System.out.println();
    }
    
    public Connection setupConnection(String driver, String url,
                                      String user, String pwd ) {
       System.out.println("Connection param = " + driver+" "+ url+ " "+ user+ " " + pwd);
       Connection cn;
       try {
          Class.forName(driver);
          cn = DriverManager.getConnection(url,user,pwd);
          this.cn = cn;
       }  catch(Exception e){
	  System.out.println("Exception while geting connection: "+ e);
          cn = null;
       }
       System.out.println("cn from setupConnection =" + " " + cn);
       return cn;
    }

        public void dbImportExport (String tableName,Connection cn,byte[] blobdata,String clobdata,String imageFile) throws ClassNotFoundException,SQLException {

        System.out.println("tableName= " + tableName +" "+ "cn= " +cn);
        Statement s = cn.createStatement();
	s.executeUpdate("DELETE FROM " + tableName );
        System.out.println(">>> Table rows deleted");

//        s.executeUpdate("drop table" + tableName);
//        s.executeUpdate("create table test (pk varchar2(255) , xmldata clob) ");
//        s.executeUpdate("insert into datatypes values ('asdf', NULL)");
        s.executeUpdate("insert into datatypes values (3,1007,null,null)");

        String updateSQL;
        PreparedStatement pstmt;
        int updaterowCount;
        Integer ID = 3;

        //Executing with two parameter markers
        updateSQL = "update datatypes set CLOBDATA=? where ID = ?";
        //System.out.println("updateSQL = " + updateSQL);
        pstmt= cn.prepareStatement(updateSQL);
        pstmt.setCharacterStream(1, new StringReader(clobdata), clobdata.length());
        pstmt.setInt(2, ID);
        updaterowCount = pstmt.executeUpdate();

	try {
        //Executing with two parameter markers
        updateSQL = "update datatypes set BLOBDATA=? where ID = ?";
        //System.out.println("updateSQL = " + updateSQL);
        pstmt= cn.prepareStatement(updateSQL);
        //pstmt.setBlob(1, blobdata);
	
	File file = new File(imageFile);
   	FileInputStream fis = new FileInputStream(file);
        pstmt.setBinaryStream(1, fis, (int)file.length());
        pstmt.setInt(2, ID);
        updaterowCount = pstmt.executeUpdate();
	} catch (SQLException e) {
        	System.out.println("e = " + e);
	} catch (FileNotFoundException e) {
        	System.out.println("e = " + e);
    	}

     } 
}
